local Bagger = {};

function Bagger:OnLoad()
	local version, major, minor = strmatch(GetBuildInfo(), '([%d]*)%.([%d]*)%.([%d]*)')
		if version == "10" then
			self:RegisterEvent("PLAYER_INTERACTION_MANAGER_FRAME_SHOW");
			self:RegisterEvent("PLAYER_INTERACTION_MANAGER_FRAME_HIDE");
		elseif version == "3" then
			self:RegisterEvent("PLAYER_INTERACTION_MANAGER_FRAME_SHOW");
			self:RegisterEvent("PLAYER_INTERACTION_MANAGER_FRAME_HIDE");
			self:RegisterEvent("AUCTION_HOUSE_SHOW");
			self:RegisterEvent("GOSSIP_SHOW");
		else
			self:RegisterEvent("AUCTION_HOUSE_SHOW");
			self:RegisterEvent("AUCTION_HOUSE_CLOSED");
			self:RegisterEvent("BANKFRAME_OPENED");
			self:RegisterEvent("BANKFRAME_CLOSED");
			self:RegisterEvent("GOSSIP_SHOW");
			self:RegisterEvent("GUILDBANKFRAME_OPENED");
			self:RegisterEvent("GUILDBANKFRAME_CLOSED");
			self:RegisterEvent("MAIL_SHOW");
			self:RegisterEvent("MAIL_CLOSED");
			self:RegisterEvent("MERCHANT_SHOW");
			self:RegisterEvent("MERCHANT_CLOSED");
			self:RegisterEvent("TRADE_SHOW");
			self:RegisterEvent("TRADE_CLOSED");
		end
	self:HookScript("OnEvent", self.OnEvent);
end

local retailEvent = {
	PLAYER_INTERACTION_MANAGER_FRAME_SHOW = true
};

local retailEndEvent = {
	PLAYER_INTERACTION_MANAGER_FRAME_HIDE = true
};

local classicEvent = {
	AUCTION_HOUSE_SHOW = true,
	BANKFRAME_OPENED = true,
	GUILDBANKFRAME_OPENED = true,
	MAIL_SHOW = true,
	MERCHANT_SHOW = true,
	TRADE_SHOW = true
};

local classicEndEvent = {
	AUCTION_HOUSE_CLOSED = true,
	BANKFRAME_CLOSED = true,
	GUILDBANKFRAME_CLOSED = true,
	MAIL_CLOSED = true,
	MERCHANT_CLOSED = true,
	TRADE_CLOSED = true
};

local gossipEvent = {
	GOSSIP_SHOW = true
};

function Bagger:OnEvent(event, ...)
--[[ Type returns: 0 is "None" and fires when closing a window, 1 is TradePartner, 8 is Banker, 10 is GuildBanker,and 53 is ItemUpgrade.]]
	if retailEvent[event] then
		local type = ...
		local retailBag = tonumber(type)
			if retailBag and retailBag == 8
			then
				local BankBags = securecall(GetNumBankSlots)
				local i
				for i = 0, BankBags do
				securecall(OpenBag, NUM_BAG_SLOTS + 1 + i)
				end
			elseif retailBag and retailBag == 1 or retailBag == 10 or retailBag == 53
			then
				securecall(OpenAllBags)
			end
	elseif retailEndEvent[event] then
		local type = ...
		local retailBag = tonumber(type)
			if retailBag and retailBag == 0 or retailBag == 1 or retailBag == 8 or retailBag == 10 or retailBag == 53
			then
				securecall(CloseAllBags)
			end
	elseif gossipEvent[event] then
		local version, major, minor = strmatch(GetBuildInfo(), '([%d]*)%.([%d]*)%.([%d]*)')
			if version == "3" then
				local gossipBag = C_GossipInfo.GetOptions()
				local chatty = #C_GossipInfo.GetOptions()
				local serious = C_GossipInfo.GetNumAvailableQuests()
				local ongoing = C_GossipInfo.GetNumActiveQuests()
						if chatty > 1 or serious > 0 or ongoing > 0 then
							return
						elseif gossipBag then
							for i, v in pairs(gossipBag) do
								if v.icon ~= 132052 then
								C_GossipInfo.SelectOption(gossipBag[1].gossipOptionID)
								end
							end
						end
			else
			local titleBag, gossipBag = GetGossipOptions()
				if gossipBag
				then
					if gossipBag == "banker"
					or gossipBag == "vendor"
					or gossipBag == "taxi"
					then
						local onlygossip = GetNumGossipOptions()
						local quests = GetNumGossipAvailableQuests()
						local onquests = GetNumGossipActiveQuests()
						local chatty = tonumber(onlygossip)
						local serious = tonumber(quests)
						local ongoing = tonumber(onquests)
							if chatty and chatty > 1 or serious > 0 or ongoing > 0 then return
							else
								SelectGossipOption(1)
							end
					end
				end
			end

	elseif classicEvent[event] then
		if (event == "BANKFRAME_OPENED") then
			local BankBags = GetNumBankSlots()
			local i
			for i = 0, BankBags do
				OpenBag(NUM_BAG_SLOTS + 1 + i)
			end
		else
			OpenAllBags()
		end
	elseif classicEndEvent[event] then
		CloseAllBags()
	end
end

local function ResetTheDamnThing()
	ReloadUI()
end

local BaggerStuff = Mixin(CreateFrame("FRAME"), Bagger);
BaggerStuff:OnLoad();

SLASH_BAGGER1 = '/rl'
  
SlashCmdList["BAGGER"] = ResetTheDamnThing

